// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/ComputedLane.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/computed_lane__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `reference_lane_id`
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__functions.h"
// Member `offset_xaxis_small`
// Member `offset_yaxis_small`
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_sm__functions.h"
// Member `offset_xaxis_large`
// Member `offset_yaxis_large`
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_lg__functions.h"
// Member `rotate_xy`
#include "etsi_its_mapem_ts_msgs/msg/detail/angle__functions.h"
// Member `scale_xaxis`
// Member `scale_yaxis`
#include "etsi_its_mapem_ts_msgs/msg/detail/scale_b12__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__init(etsi_its_mapem_ts_msgs__msg__ComputedLane * msg)
{
  if (!msg) {
    return false;
  }
  // reference_lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__init(&msg->reference_lane_id)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // offset_xaxis_choice
  // offset_xaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__init(&msg->offset_xaxis_small)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // offset_xaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__init(&msg->offset_xaxis_large)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // offset_yaxis_choice
  // offset_yaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__init(&msg->offset_yaxis_small)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // offset_yaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__init(&msg->offset_yaxis_large)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // rotate_xy
  if (!etsi_its_mapem_ts_msgs__msg__Angle__init(&msg->rotate_xy)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // rotate_xy_is_present
  // scale_xaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__init(&msg->scale_xaxis)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // scale_xaxis_is_present
  // scale_yaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__init(&msg->scale_yaxis)) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
    return false;
  }
  // scale_yaxis_is_present
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(etsi_its_mapem_ts_msgs__msg__ComputedLane * msg)
{
  if (!msg) {
    return;
  }
  // reference_lane_id
  etsi_its_mapem_ts_msgs__msg__LaneID__fini(&msg->reference_lane_id);
  // offset_xaxis_choice
  // offset_xaxis_small
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__fini(&msg->offset_xaxis_small);
  // offset_xaxis_large
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__fini(&msg->offset_xaxis_large);
  // offset_yaxis_choice
  // offset_yaxis_small
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__fini(&msg->offset_yaxis_small);
  // offset_yaxis_large
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__fini(&msg->offset_yaxis_large);
  // rotate_xy
  etsi_its_mapem_ts_msgs__msg__Angle__fini(&msg->rotate_xy);
  // rotate_xy_is_present
  // scale_xaxis
  etsi_its_mapem_ts_msgs__msg__ScaleB12__fini(&msg->scale_xaxis);
  // scale_xaxis_is_present
  // scale_yaxis
  etsi_its_mapem_ts_msgs__msg__ScaleB12__fini(&msg->scale_yaxis);
  // scale_yaxis_is_present
}

bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__are_equal(const etsi_its_mapem_ts_msgs__msg__ComputedLane * lhs, const etsi_its_mapem_ts_msgs__msg__ComputedLane * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // reference_lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__are_equal(
      &(lhs->reference_lane_id), &(rhs->reference_lane_id)))
  {
    return false;
  }
  // offset_xaxis_choice
  if (lhs->offset_xaxis_choice != rhs->offset_xaxis_choice) {
    return false;
  }
  // offset_xaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__are_equal(
      &(lhs->offset_xaxis_small), &(rhs->offset_xaxis_small)))
  {
    return false;
  }
  // offset_xaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__are_equal(
      &(lhs->offset_xaxis_large), &(rhs->offset_xaxis_large)))
  {
    return false;
  }
  // offset_yaxis_choice
  if (lhs->offset_yaxis_choice != rhs->offset_yaxis_choice) {
    return false;
  }
  // offset_yaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__are_equal(
      &(lhs->offset_yaxis_small), &(rhs->offset_yaxis_small)))
  {
    return false;
  }
  // offset_yaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__are_equal(
      &(lhs->offset_yaxis_large), &(rhs->offset_yaxis_large)))
  {
    return false;
  }
  // rotate_xy
  if (!etsi_its_mapem_ts_msgs__msg__Angle__are_equal(
      &(lhs->rotate_xy), &(rhs->rotate_xy)))
  {
    return false;
  }
  // rotate_xy_is_present
  if (lhs->rotate_xy_is_present != rhs->rotate_xy_is_present) {
    return false;
  }
  // scale_xaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__are_equal(
      &(lhs->scale_xaxis), &(rhs->scale_xaxis)))
  {
    return false;
  }
  // scale_xaxis_is_present
  if (lhs->scale_xaxis_is_present != rhs->scale_xaxis_is_present) {
    return false;
  }
  // scale_yaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__are_equal(
      &(lhs->scale_yaxis), &(rhs->scale_yaxis)))
  {
    return false;
  }
  // scale_yaxis_is_present
  if (lhs->scale_yaxis_is_present != rhs->scale_yaxis_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__copy(
  const etsi_its_mapem_ts_msgs__msg__ComputedLane * input,
  etsi_its_mapem_ts_msgs__msg__ComputedLane * output)
{
  if (!input || !output) {
    return false;
  }
  // reference_lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__copy(
      &(input->reference_lane_id), &(output->reference_lane_id)))
  {
    return false;
  }
  // offset_xaxis_choice
  output->offset_xaxis_choice = input->offset_xaxis_choice;
  // offset_xaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__copy(
      &(input->offset_xaxis_small), &(output->offset_xaxis_small)))
  {
    return false;
  }
  // offset_xaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__copy(
      &(input->offset_xaxis_large), &(output->offset_xaxis_large)))
  {
    return false;
  }
  // offset_yaxis_choice
  output->offset_yaxis_choice = input->offset_yaxis_choice;
  // offset_yaxis_small
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm__copy(
      &(input->offset_yaxis_small), &(output->offset_yaxis_small)))
  {
    return false;
  }
  // offset_yaxis_large
  if (!etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg__copy(
      &(input->offset_yaxis_large), &(output->offset_yaxis_large)))
  {
    return false;
  }
  // rotate_xy
  if (!etsi_its_mapem_ts_msgs__msg__Angle__copy(
      &(input->rotate_xy), &(output->rotate_xy)))
  {
    return false;
  }
  // rotate_xy_is_present
  output->rotate_xy_is_present = input->rotate_xy_is_present;
  // scale_xaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__copy(
      &(input->scale_xaxis), &(output->scale_xaxis)))
  {
    return false;
  }
  // scale_xaxis_is_present
  output->scale_xaxis_is_present = input->scale_xaxis_is_present;
  // scale_yaxis
  if (!etsi_its_mapem_ts_msgs__msg__ScaleB12__copy(
      &(input->scale_yaxis), &(output->scale_yaxis)))
  {
    return false;
  }
  // scale_yaxis_is_present
  output->scale_yaxis_is_present = input->scale_yaxis_is_present;
  return true;
}

etsi_its_mapem_ts_msgs__msg__ComputedLane *
etsi_its_mapem_ts_msgs__msg__ComputedLane__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__ComputedLane * msg = (etsi_its_mapem_ts_msgs__msg__ComputedLane *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__ComputedLane), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__ComputedLane));
  bool success = etsi_its_mapem_ts_msgs__msg__ComputedLane__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__ComputedLane__destroy(etsi_its_mapem_ts_msgs__msg__ComputedLane * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__init(etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__ComputedLane * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__ComputedLane *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__ComputedLane), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__ComputedLane__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__fini(etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence *
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * array = (etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__ComputedLane__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__ComputedLane);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__ComputedLane * data =
      (etsi_its_mapem_ts_msgs__msg__ComputedLane *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__ComputedLane__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__ComputedLane__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__ComputedLane__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
