// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/ComputedLane.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_OFFSET_XAXIS_SMALL'.
enum
{
  etsi_its_mapem_ts_msgs__msg__ComputedLane__CHOICE_OFFSET_XAXIS_SMALL = 0
};

/// Constant 'CHOICE_OFFSET_XAXIS_LARGE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__ComputedLane__CHOICE_OFFSET_XAXIS_LARGE = 1
};

/// Constant 'CHOICE_OFFSET_YAXIS_SMALL'.
enum
{
  etsi_its_mapem_ts_msgs__msg__ComputedLane__CHOICE_OFFSET_YAXIS_SMALL = 0
};

/// Constant 'CHOICE_OFFSET_YAXIS_LARGE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__ComputedLane__CHOICE_OFFSET_YAXIS_LARGE = 1
};

// Include directives for member types
// Member 'reference_lane_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__struct.h"
// Member 'offset_xaxis_small'
// Member 'offset_yaxis_small'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_sm__struct.h"
// Member 'offset_xaxis_large'
// Member 'offset_yaxis_large'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_lg__struct.h"
// Member 'rotate_xy'
#include "etsi_its_mapem_ts_msgs/msg/detail/angle__struct.h"
// Member 'scale_xaxis'
// Member 'scale_yaxis'
#include "etsi_its_mapem_ts_msgs/msg/detail/scale_b12__struct.h"

/// Struct defined in msg/ComputedLane in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__ComputedLane
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ComputedLane ::= SEQUENCE {
  ///   referenceLaneId    LaneID,
  ///   offsetXaxis        CHOICE {
  ///                         small   DrivenLineOffsetSm,
  ///                         large   DrivenLineOffsetLg
  ///                         },
  ///   offsetYaxis        CHOICE {
  ///                         small   DrivenLineOffsetSm,
  ///                         large   DrivenLineOffsetLg
  ///                         },
  ///   rotateXY           Angle OPTIONAL,
  ///   scaleXaxis         Scale-B12 OPTIONAL,
  ///   scaleYaxis         Scale-B12 OPTIONAL,
  ///   regional  SEQUENCE (SIZE(1..4)) OF
  ///             RegionalExtension {{Reg-ComputedLane}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_mapem_ts_msgs__msg__LaneID reference_lane_id;
  uint8_t offset_xaxis_choice;
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm offset_xaxis_small;
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg offset_xaxis_large;
  uint8_t offset_yaxis_choice;
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetSm offset_yaxis_small;
  etsi_its_mapem_ts_msgs__msg__DrivenLineOffsetLg offset_yaxis_large;
  etsi_its_mapem_ts_msgs__msg__Angle rotate_xy;
  bool rotate_xy_is_present;
  etsi_its_mapem_ts_msgs__msg__ScaleB12 scale_xaxis;
  bool scale_xaxis_is_present;
  etsi_its_mapem_ts_msgs__msg__ScaleB12 scale_yaxis;
  bool scale_yaxis_is_present;
} etsi_its_mapem_ts_msgs__msg__ComputedLane;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__ComputedLane.
typedef struct etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence
{
  etsi_its_mapem_ts_msgs__msg__ComputedLane * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__ComputedLane__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_H_
