// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/Connection.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'connecting_lane'
#include "etsi_its_mapem_ts_msgs/msg/detail/connecting_lane__struct.hpp"
// Member 'remote_intersection'
#include "etsi_its_mapem_ts_msgs/msg/detail/intersection_reference_id__struct.hpp"
// Member 'signal_group'
#include "etsi_its_mapem_ts_msgs/msg/detail/signal_group_id__struct.hpp"
// Member 'user_class'
#include "etsi_its_mapem_ts_msgs/msg/detail/restriction_class_id__struct.hpp"
// Member 'connection_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_connection_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__Connection __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__Connection __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Connection_
{
  using Type = Connection_<ContainerAllocator>;

  explicit Connection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : connecting_lane(_init),
    remote_intersection(_init),
    signal_group(_init),
    user_class(_init),
    connection_id(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->remote_intersection_is_present = false;
      this->signal_group_is_present = false;
      this->user_class_is_present = false;
      this->connection_id_is_present = false;
    }
  }

  explicit Connection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : connecting_lane(_alloc, _init),
    remote_intersection(_alloc, _init),
    signal_group(_alloc, _init),
    user_class(_alloc, _init),
    connection_id(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->remote_intersection_is_present = false;
      this->signal_group_is_present = false;
      this->user_class_is_present = false;
      this->connection_id_is_present = false;
    }
  }

  // field types and members
  using _connecting_lane_type =
    etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>;
  _connecting_lane_type connecting_lane;
  using _remote_intersection_type =
    etsi_its_mapem_ts_msgs::msg::IntersectionReferenceID_<ContainerAllocator>;
  _remote_intersection_type remote_intersection;
  using _remote_intersection_is_present_type =
    bool;
  _remote_intersection_is_present_type remote_intersection_is_present;
  using _signal_group_type =
    etsi_its_mapem_ts_msgs::msg::SignalGroupID_<ContainerAllocator>;
  _signal_group_type signal_group;
  using _signal_group_is_present_type =
    bool;
  _signal_group_is_present_type signal_group_is_present;
  using _user_class_type =
    etsi_its_mapem_ts_msgs::msg::RestrictionClassID_<ContainerAllocator>;
  _user_class_type user_class;
  using _user_class_is_present_type =
    bool;
  _user_class_is_present_type user_class_is_present;
  using _connection_id_type =
    etsi_its_mapem_ts_msgs::msg::LaneConnectionID_<ContainerAllocator>;
  _connection_id_type connection_id;
  using _connection_id_is_present_type =
    bool;
  _connection_id_is_present_type connection_id_is_present;

  // setters for named parameter idiom
  Type & set__connecting_lane(
    const etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> & _arg)
  {
    this->connecting_lane = _arg;
    return *this;
  }
  Type & set__remote_intersection(
    const etsi_its_mapem_ts_msgs::msg::IntersectionReferenceID_<ContainerAllocator> & _arg)
  {
    this->remote_intersection = _arg;
    return *this;
  }
  Type & set__remote_intersection_is_present(
    const bool & _arg)
  {
    this->remote_intersection_is_present = _arg;
    return *this;
  }
  Type & set__signal_group(
    const etsi_its_mapem_ts_msgs::msg::SignalGroupID_<ContainerAllocator> & _arg)
  {
    this->signal_group = _arg;
    return *this;
  }
  Type & set__signal_group_is_present(
    const bool & _arg)
  {
    this->signal_group_is_present = _arg;
    return *this;
  }
  Type & set__user_class(
    const etsi_its_mapem_ts_msgs::msg::RestrictionClassID_<ContainerAllocator> & _arg)
  {
    this->user_class = _arg;
    return *this;
  }
  Type & set__user_class_is_present(
    const bool & _arg)
  {
    this->user_class_is_present = _arg;
    return *this;
  }
  Type & set__connection_id(
    const etsi_its_mapem_ts_msgs::msg::LaneConnectionID_<ContainerAllocator> & _arg)
  {
    this->connection_id = _arg;
    return *this;
  }
  Type & set__connection_id_is_present(
    const bool & _arg)
  {
    this->connection_id_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__Connection
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__Connection
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Connection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Connection_ & other) const
  {
    if (this->connecting_lane != other.connecting_lane) {
      return false;
    }
    if (this->remote_intersection != other.remote_intersection) {
      return false;
    }
    if (this->remote_intersection_is_present != other.remote_intersection_is_present) {
      return false;
    }
    if (this->signal_group != other.signal_group) {
      return false;
    }
    if (this->signal_group_is_present != other.signal_group_is_present) {
      return false;
    }
    if (this->user_class != other.user_class) {
      return false;
    }
    if (this->user_class_is_present != other.user_class_is_present) {
      return false;
    }
    if (this->connection_id != other.connection_id) {
      return false;
    }
    if (this->connection_id_is_present != other.connection_id_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const Connection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Connection_

// alias to use template instance with default allocator
using Connection =
  etsi_its_mapem_ts_msgs::msg::Connection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__STRUCT_HPP_
