// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/ConnectingLane.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__struct.hpp"
// Member 'maneuver'
#include "etsi_its_mapem_ts_msgs/msg/detail/allowed_maneuvers__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__ConnectingLane __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__ConnectingLane __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ConnectingLane_
{
  using Type = ConnectingLane_<ContainerAllocator>;

  explicit ConnectingLane_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane(_init),
    maneuver(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->maneuver_is_present = false;
    }
  }

  explicit ConnectingLane_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane(_alloc, _init),
    maneuver(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->maneuver_is_present = false;
    }
  }

  // field types and members
  using _lane_type =
    etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator>;
  _lane_type lane;
  using _maneuver_type =
    etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>;
  _maneuver_type maneuver;
  using _maneuver_is_present_type =
    bool;
  _maneuver_is_present_type maneuver_is_present;

  // setters for named parameter idiom
  Type & set__lane(
    const etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator> & _arg)
  {
    this->lane = _arg;
    return *this;
  }
  Type & set__maneuver(
    const etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> & _arg)
  {
    this->maneuver = _arg;
    return *this;
  }
  Type & set__maneuver_is_present(
    const bool & _arg)
  {
    this->maneuver_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__ConnectingLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__ConnectingLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ConnectingLane_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ConnectingLane_ & other) const
  {
    if (this->lane != other.lane) {
      return false;
    }
    if (this->maneuver != other.maneuver) {
      return false;
    }
    if (this->maneuver_is_present != other.maneuver_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ConnectingLane_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ConnectingLane_

// alias to use template instance with default allocator
using ConnectingLane =
  etsi_its_mapem_ts_msgs::msg::ConnectingLane_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__STRUCT_HPP_
