// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/GenericLane.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__struct.hpp"
// Member 'name'
#include "etsi_its_mapem_ts_msgs/msg/detail/descriptive_name__struct.hpp"
// Member 'ingress_approach'
// Member 'egress_approach'
#include "etsi_its_mapem_ts_msgs/msg/detail/approach_id__struct.hpp"
// Member 'lane_attributes'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes__struct.hpp"
// Member 'maneuvers'
#include "etsi_its_mapem_ts_msgs/msg/detail/allowed_maneuvers__struct.hpp"
// Member 'node_list'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_list_xy__struct.hpp"
// Member 'connects_to'
#include "etsi_its_mapem_ts_msgs/msg/detail/connects_to_list__struct.hpp"
// Member 'overlays'
#include "etsi_its_mapem_ts_msgs/msg/detail/overlay_lane_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__GenericLane __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__GenericLane __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GenericLane_
{
  using Type = GenericLane_<ContainerAllocator>;

  explicit GenericLane_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_init),
    name(_init),
    ingress_approach(_init),
    egress_approach(_init),
    lane_attributes(_init),
    maneuvers(_init),
    node_list(_init),
    connects_to(_init),
    overlays(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->ingress_approach_is_present = false;
      this->egress_approach_is_present = false;
      this->maneuvers_is_present = false;
      this->connects_to_is_present = false;
      this->overlays_is_present = false;
    }
  }

  explicit GenericLane_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_alloc, _init),
    name(_alloc, _init),
    ingress_approach(_alloc, _init),
    egress_approach(_alloc, _init),
    lane_attributes(_alloc, _init),
    maneuvers(_alloc, _init),
    node_list(_alloc, _init),
    connects_to(_alloc, _init),
    overlays(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->ingress_approach_is_present = false;
      this->egress_approach_is_present = false;
      this->maneuvers_is_present = false;
      this->connects_to_is_present = false;
      this->overlays_is_present = false;
    }
  }

  // field types and members
  using _lane_id_type =
    etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator>;
  _lane_id_type lane_id;
  using _name_type =
    etsi_its_mapem_ts_msgs::msg::DescriptiveName_<ContainerAllocator>;
  _name_type name;
  using _name_is_present_type =
    bool;
  _name_is_present_type name_is_present;
  using _ingress_approach_type =
    etsi_its_mapem_ts_msgs::msg::ApproachID_<ContainerAllocator>;
  _ingress_approach_type ingress_approach;
  using _ingress_approach_is_present_type =
    bool;
  _ingress_approach_is_present_type ingress_approach_is_present;
  using _egress_approach_type =
    etsi_its_mapem_ts_msgs::msg::ApproachID_<ContainerAllocator>;
  _egress_approach_type egress_approach;
  using _egress_approach_is_present_type =
    bool;
  _egress_approach_is_present_type egress_approach_is_present;
  using _lane_attributes_type =
    etsi_its_mapem_ts_msgs::msg::LaneAttributes_<ContainerAllocator>;
  _lane_attributes_type lane_attributes;
  using _maneuvers_type =
    etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>;
  _maneuvers_type maneuvers;
  using _maneuvers_is_present_type =
    bool;
  _maneuvers_is_present_type maneuvers_is_present;
  using _node_list_type =
    etsi_its_mapem_ts_msgs::msg::NodeListXY_<ContainerAllocator>;
  _node_list_type node_list;
  using _connects_to_type =
    etsi_its_mapem_ts_msgs::msg::ConnectsToList_<ContainerAllocator>;
  _connects_to_type connects_to;
  using _connects_to_is_present_type =
    bool;
  _connects_to_is_present_type connects_to_is_present;
  using _overlays_type =
    etsi_its_mapem_ts_msgs::msg::OverlayLaneList_<ContainerAllocator>;
  _overlays_type overlays;
  using _overlays_is_present_type =
    bool;
  _overlays_is_present_type overlays_is_present;

  // setters for named parameter idiom
  Type & set__lane_id(
    const etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator> & _arg)
  {
    this->lane_id = _arg;
    return *this;
  }
  Type & set__name(
    const etsi_its_mapem_ts_msgs::msg::DescriptiveName_<ContainerAllocator> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__name_is_present(
    const bool & _arg)
  {
    this->name_is_present = _arg;
    return *this;
  }
  Type & set__ingress_approach(
    const etsi_its_mapem_ts_msgs::msg::ApproachID_<ContainerAllocator> & _arg)
  {
    this->ingress_approach = _arg;
    return *this;
  }
  Type & set__ingress_approach_is_present(
    const bool & _arg)
  {
    this->ingress_approach_is_present = _arg;
    return *this;
  }
  Type & set__egress_approach(
    const etsi_its_mapem_ts_msgs::msg::ApproachID_<ContainerAllocator> & _arg)
  {
    this->egress_approach = _arg;
    return *this;
  }
  Type & set__egress_approach_is_present(
    const bool & _arg)
  {
    this->egress_approach_is_present = _arg;
    return *this;
  }
  Type & set__lane_attributes(
    const etsi_its_mapem_ts_msgs::msg::LaneAttributes_<ContainerAllocator> & _arg)
  {
    this->lane_attributes = _arg;
    return *this;
  }
  Type & set__maneuvers(
    const etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> & _arg)
  {
    this->maneuvers = _arg;
    return *this;
  }
  Type & set__maneuvers_is_present(
    const bool & _arg)
  {
    this->maneuvers_is_present = _arg;
    return *this;
  }
  Type & set__node_list(
    const etsi_its_mapem_ts_msgs::msg::NodeListXY_<ContainerAllocator> & _arg)
  {
    this->node_list = _arg;
    return *this;
  }
  Type & set__connects_to(
    const etsi_its_mapem_ts_msgs::msg::ConnectsToList_<ContainerAllocator> & _arg)
  {
    this->connects_to = _arg;
    return *this;
  }
  Type & set__connects_to_is_present(
    const bool & _arg)
  {
    this->connects_to_is_present = _arg;
    return *this;
  }
  Type & set__overlays(
    const etsi_its_mapem_ts_msgs::msg::OverlayLaneList_<ContainerAllocator> & _arg)
  {
    this->overlays = _arg;
    return *this;
  }
  Type & set__overlays_is_present(
    const bool & _arg)
  {
    this->overlays_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__GenericLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__GenericLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::GenericLane_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GenericLane_ & other) const
  {
    if (this->lane_id != other.lane_id) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->name_is_present != other.name_is_present) {
      return false;
    }
    if (this->ingress_approach != other.ingress_approach) {
      return false;
    }
    if (this->ingress_approach_is_present != other.ingress_approach_is_present) {
      return false;
    }
    if (this->egress_approach != other.egress_approach) {
      return false;
    }
    if (this->egress_approach_is_present != other.egress_approach_is_present) {
      return false;
    }
    if (this->lane_attributes != other.lane_attributes) {
      return false;
    }
    if (this->maneuvers != other.maneuvers) {
      return false;
    }
    if (this->maneuvers_is_present != other.maneuvers_is_present) {
      return false;
    }
    if (this->node_list != other.node_list) {
      return false;
    }
    if (this->connects_to != other.connects_to) {
      return false;
    }
    if (this->connects_to_is_present != other.connects_to_is_present) {
      return false;
    }
    if (this->overlays != other.overlays) {
      return false;
    }
    if (this->overlays_is_present != other.overlays_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const GenericLane_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GenericLane_

// alias to use template instance with default allocator
using GenericLane =
  etsi_its_mapem_ts_msgs::msg::GenericLane_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__STRUCT_HPP_
