// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneAttributesCrosswalk.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_CROSSWALK__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_CROSSWALK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__SIZE_BITS = 16
};

/// Constant 'BIT_INDEX_CROSSWALK_REVOCABLE_LANE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_CROSSWALK_REVOCABLE_LANE = 0
};

/// Constant 'BIT_INDEX_BICYLE_USE_ALLOWED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_BICYLE_USE_ALLOWED = 1
};

/// Constant 'BIT_INDEX_IS_XWALK_FLY_OVER_LANE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_IS_XWALK_FLY_OVER_LANE = 2
};

/// Constant 'BIT_INDEX_FIXED_CYCLE_TIME'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_FIXED_CYCLE_TIME = 3
};

/// Constant 'BIT_INDEX_BI_DIRECTIONAL_CYCLE_TIMES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_BI_DIRECTIONAL_CYCLE_TIMES = 4
};

/// Constant 'BIT_INDEX_HAS_PUSH_TO_WALK_BUTTON'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_HAS_PUSH_TO_WALK_BUTTON = 5
};

/// Constant 'BIT_INDEX_AUDIO_SUPPORT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_AUDIO_SUPPORT = 6
};

/// Constant 'BIT_INDEX_RF_SIGNAL_REQUEST_PRESENT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_RF_SIGNAL_REQUEST_PRESENT = 7
};

/// Constant 'BIT_INDEX_UNSIGNALIZED_SEGMENTS_PRESENT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__BIT_INDEX_UNSIGNALIZED_SEGMENTS_PRESENT = 8
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/LaneAttributesCrosswalk in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LaneAttributes-Crosswalk ::= BIT STRING {
  ///   crosswalkRevocableLane  (0),
  ///   bicyleUseAllowed        (1),
  ///   isXwalkFlyOverLane      (2),
  ///   fixedCycleTime          (3),
  ///   biDirectionalCycleTimes (4),
  ///   hasPushToWalkButton     (5),
  ///   audioSupport            (6),
  ///   rfSignalRequestPresent  (7),
  ///   unsignalizedSegmentsPresent  (8)
  /// } (SIZE (16))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk.
typedef struct etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__Sequence
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_CROSSWALK__STRUCT_H_
