// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneSharing.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_SHARING__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_SHARING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__SIZE_BITS = 10
};

/// Constant 'BIT_INDEX_OVERLAPPING_LANE_DESCRIPTION_PROVIDED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_OVERLAPPING_LANE_DESCRIPTION_PROVIDED = 0
};

/// Constant 'BIT_INDEX_MULTIPLE_LANES_TREATED_AS_ONE_LANE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_MULTIPLE_LANES_TREATED_AS_ONE_LANE = 1
};

/// Constant 'BIT_INDEX_OTHER_NON_MOTORIZED_TRAFFIC_TYPES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_OTHER_NON_MOTORIZED_TRAFFIC_TYPES = 2
};

/// Constant 'BIT_INDEX_INDIVIDUAL_MOTORIZED_VEHICLE_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_INDIVIDUAL_MOTORIZED_VEHICLE_TRAFFIC = 3
};

/// Constant 'BIT_INDEX_BUS_VEHICLE_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_BUS_VEHICLE_TRAFFIC = 4
};

/// Constant 'BIT_INDEX_TAXI_VEHICLE_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_TAXI_VEHICLE_TRAFFIC = 5
};

/// Constant 'BIT_INDEX_PEDESTRIANS_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_PEDESTRIANS_TRAFFIC = 6
};

/// Constant 'BIT_INDEX_CYCLIST_VEHICLE_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_CYCLIST_VEHICLE_TRAFFIC = 7
};

/// Constant 'BIT_INDEX_TRACKED_VEHICLE_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_TRACKED_VEHICLE_TRAFFIC = 8
};

/// Constant 'BIT_INDEX_PEDESTRIAN_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing__BIT_INDEX_PEDESTRIAN_TRAFFIC = 9
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/LaneSharing in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__LaneSharing
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LaneSharing ::= BIT STRING {
  ///    overlappingLaneDescriptionProvided  (0),
  ///    multipleLanesTreatedAsOneLane       (1),
  ///    otherNonMotorizedTrafficTypes       (2),
  ///    individualMotorizedVehicleTraffic   (3),
  ///    busVehicleTraffic                   (4),
  ///    taxiVehicleTraffic                  (5),
  ///    pedestriansTraffic                  (6),
  ///    cyclistVehicleTraffic               (7),
  ///    trackedVehicleTraffic               (8),
  ///    pedestrianTraffic                   (9)
  /// } (SIZE (10))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_mapem_ts_msgs__msg__LaneSharing;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__LaneSharing.
typedef struct etsi_its_mapem_ts_msgs__msg__LaneSharing__Sequence
{
  etsi_its_mapem_ts_msgs__msg__LaneSharing * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__LaneSharing__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_SHARING__STRUCT_H_
