// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/MapData.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/map_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `time_stamp`
#include "etsi_its_mapem_ts_msgs/msg/detail/minute_of_the_year__functions.h"
// Member `msg_issue_revision`
#include "etsi_its_mapem_ts_msgs/msg/detail/msg_count__functions.h"
// Member `layer_type`
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_type__functions.h"
// Member `layer_id`
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_id__functions.h"
// Member `intersections`
#include "etsi_its_mapem_ts_msgs/msg/detail/intersection_geometry_list__functions.h"
// Member `road_segments`
#include "etsi_its_mapem_ts_msgs/msg/detail/road_segment_list__functions.h"
// Member `data_parameters`
#include "etsi_its_mapem_ts_msgs/msg/detail/data_parameters__functions.h"
// Member `restriction_list`
#include "etsi_its_mapem_ts_msgs/msg/detail/restriction_class_list__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__MapData__init(etsi_its_mapem_ts_msgs__msg__MapData * msg)
{
  if (!msg) {
    return false;
  }
  // time_stamp
  if (!etsi_its_mapem_ts_msgs__msg__MinuteOfTheYear__init(&msg->time_stamp)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // time_stamp_is_present
  // msg_issue_revision
  if (!etsi_its_mapem_ts_msgs__msg__MsgCount__init(&msg->msg_issue_revision)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // layer_type
  if (!etsi_its_mapem_ts_msgs__msg__LayerType__init(&msg->layer_type)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // layer_type_is_present
  // layer_id
  if (!etsi_its_mapem_ts_msgs__msg__LayerID__init(&msg->layer_id)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // layer_id_is_present
  // intersections
  if (!etsi_its_mapem_ts_msgs__msg__IntersectionGeometryList__init(&msg->intersections)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // intersections_is_present
  // road_segments
  if (!etsi_its_mapem_ts_msgs__msg__RoadSegmentList__init(&msg->road_segments)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // road_segments_is_present
  // data_parameters
  if (!etsi_its_mapem_ts_msgs__msg__DataParameters__init(&msg->data_parameters)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // data_parameters_is_present
  // restriction_list
  if (!etsi_its_mapem_ts_msgs__msg__RestrictionClassList__init(&msg->restriction_list)) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
    return false;
  }
  // restriction_list_is_present
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__MapData__fini(etsi_its_mapem_ts_msgs__msg__MapData * msg)
{
  if (!msg) {
    return;
  }
  // time_stamp
  etsi_its_mapem_ts_msgs__msg__MinuteOfTheYear__fini(&msg->time_stamp);
  // time_stamp_is_present
  // msg_issue_revision
  etsi_its_mapem_ts_msgs__msg__MsgCount__fini(&msg->msg_issue_revision);
  // layer_type
  etsi_its_mapem_ts_msgs__msg__LayerType__fini(&msg->layer_type);
  // layer_type_is_present
  // layer_id
  etsi_its_mapem_ts_msgs__msg__LayerID__fini(&msg->layer_id);
  // layer_id_is_present
  // intersections
  etsi_its_mapem_ts_msgs__msg__IntersectionGeometryList__fini(&msg->intersections);
  // intersections_is_present
  // road_segments
  etsi_its_mapem_ts_msgs__msg__RoadSegmentList__fini(&msg->road_segments);
  // road_segments_is_present
  // data_parameters
  etsi_its_mapem_ts_msgs__msg__DataParameters__fini(&msg->data_parameters);
  // data_parameters_is_present
  // restriction_list
  etsi_its_mapem_ts_msgs__msg__RestrictionClassList__fini(&msg->restriction_list);
  // restriction_list_is_present
}

bool
etsi_its_mapem_ts_msgs__msg__MapData__are_equal(const etsi_its_mapem_ts_msgs__msg__MapData * lhs, const etsi_its_mapem_ts_msgs__msg__MapData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // time_stamp
  if (!etsi_its_mapem_ts_msgs__msg__MinuteOfTheYear__are_equal(
      &(lhs->time_stamp), &(rhs->time_stamp)))
  {
    return false;
  }
  // time_stamp_is_present
  if (lhs->time_stamp_is_present != rhs->time_stamp_is_present) {
    return false;
  }
  // msg_issue_revision
  if (!etsi_its_mapem_ts_msgs__msg__MsgCount__are_equal(
      &(lhs->msg_issue_revision), &(rhs->msg_issue_revision)))
  {
    return false;
  }
  // layer_type
  if (!etsi_its_mapem_ts_msgs__msg__LayerType__are_equal(
      &(lhs->layer_type), &(rhs->layer_type)))
  {
    return false;
  }
  // layer_type_is_present
  if (lhs->layer_type_is_present != rhs->layer_type_is_present) {
    return false;
  }
  // layer_id
  if (!etsi_its_mapem_ts_msgs__msg__LayerID__are_equal(
      &(lhs->layer_id), &(rhs->layer_id)))
  {
    return false;
  }
  // layer_id_is_present
  if (lhs->layer_id_is_present != rhs->layer_id_is_present) {
    return false;
  }
  // intersections
  if (!etsi_its_mapem_ts_msgs__msg__IntersectionGeometryList__are_equal(
      &(lhs->intersections), &(rhs->intersections)))
  {
    return false;
  }
  // intersections_is_present
  if (lhs->intersections_is_present != rhs->intersections_is_present) {
    return false;
  }
  // road_segments
  if (!etsi_its_mapem_ts_msgs__msg__RoadSegmentList__are_equal(
      &(lhs->road_segments), &(rhs->road_segments)))
  {
    return false;
  }
  // road_segments_is_present
  if (lhs->road_segments_is_present != rhs->road_segments_is_present) {
    return false;
  }
  // data_parameters
  if (!etsi_its_mapem_ts_msgs__msg__DataParameters__are_equal(
      &(lhs->data_parameters), &(rhs->data_parameters)))
  {
    return false;
  }
  // data_parameters_is_present
  if (lhs->data_parameters_is_present != rhs->data_parameters_is_present) {
    return false;
  }
  // restriction_list
  if (!etsi_its_mapem_ts_msgs__msg__RestrictionClassList__are_equal(
      &(lhs->restriction_list), &(rhs->restriction_list)))
  {
    return false;
  }
  // restriction_list_is_present
  if (lhs->restriction_list_is_present != rhs->restriction_list_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__MapData__copy(
  const etsi_its_mapem_ts_msgs__msg__MapData * input,
  etsi_its_mapem_ts_msgs__msg__MapData * output)
{
  if (!input || !output) {
    return false;
  }
  // time_stamp
  if (!etsi_its_mapem_ts_msgs__msg__MinuteOfTheYear__copy(
      &(input->time_stamp), &(output->time_stamp)))
  {
    return false;
  }
  // time_stamp_is_present
  output->time_stamp_is_present = input->time_stamp_is_present;
  // msg_issue_revision
  if (!etsi_its_mapem_ts_msgs__msg__MsgCount__copy(
      &(input->msg_issue_revision), &(output->msg_issue_revision)))
  {
    return false;
  }
  // layer_type
  if (!etsi_its_mapem_ts_msgs__msg__LayerType__copy(
      &(input->layer_type), &(output->layer_type)))
  {
    return false;
  }
  // layer_type_is_present
  output->layer_type_is_present = input->layer_type_is_present;
  // layer_id
  if (!etsi_its_mapem_ts_msgs__msg__LayerID__copy(
      &(input->layer_id), &(output->layer_id)))
  {
    return false;
  }
  // layer_id_is_present
  output->layer_id_is_present = input->layer_id_is_present;
  // intersections
  if (!etsi_its_mapem_ts_msgs__msg__IntersectionGeometryList__copy(
      &(input->intersections), &(output->intersections)))
  {
    return false;
  }
  // intersections_is_present
  output->intersections_is_present = input->intersections_is_present;
  // road_segments
  if (!etsi_its_mapem_ts_msgs__msg__RoadSegmentList__copy(
      &(input->road_segments), &(output->road_segments)))
  {
    return false;
  }
  // road_segments_is_present
  output->road_segments_is_present = input->road_segments_is_present;
  // data_parameters
  if (!etsi_its_mapem_ts_msgs__msg__DataParameters__copy(
      &(input->data_parameters), &(output->data_parameters)))
  {
    return false;
  }
  // data_parameters_is_present
  output->data_parameters_is_present = input->data_parameters_is_present;
  // restriction_list
  if (!etsi_its_mapem_ts_msgs__msg__RestrictionClassList__copy(
      &(input->restriction_list), &(output->restriction_list)))
  {
    return false;
  }
  // restriction_list_is_present
  output->restriction_list_is_present = input->restriction_list_is_present;
  return true;
}

etsi_its_mapem_ts_msgs__msg__MapData *
etsi_its_mapem_ts_msgs__msg__MapData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__MapData * msg = (etsi_its_mapem_ts_msgs__msg__MapData *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__MapData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__MapData));
  bool success = etsi_its_mapem_ts_msgs__msg__MapData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__MapData__destroy(etsi_its_mapem_ts_msgs__msg__MapData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__MapData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__init(etsi_its_mapem_ts_msgs__msg__MapData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__MapData * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__MapData *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__MapData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__MapData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__MapData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__fini(etsi_its_mapem_ts_msgs__msg__MapData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__MapData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__MapData__Sequence *
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__MapData__Sequence * array = (etsi_its_mapem_ts_msgs__msg__MapData__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__MapData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__MapData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__MapData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__MapData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__MapData__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__MapData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__MapData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__MapData__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__MapData__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__MapData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__MapData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__MapData * data =
      (etsi_its_mapem_ts_msgs__msg__MapData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__MapData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__MapData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__MapData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
