// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/MapData.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/map_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'time_stamp'
#include "etsi_its_mapem_ts_msgs/msg/detail/minute_of_the_year__traits.hpp"
// Member 'msg_issue_revision'
#include "etsi_its_mapem_ts_msgs/msg/detail/msg_count__traits.hpp"
// Member 'layer_type'
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_type__traits.hpp"
// Member 'layer_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_id__traits.hpp"
// Member 'intersections'
#include "etsi_its_mapem_ts_msgs/msg/detail/intersection_geometry_list__traits.hpp"
// Member 'road_segments'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_segment_list__traits.hpp"
// Member 'data_parameters'
#include "etsi_its_mapem_ts_msgs/msg/detail/data_parameters__traits.hpp"
// Member 'restriction_list'
#include "etsi_its_mapem_ts_msgs/msg/detail/restriction_class_list__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MapData & msg,
  std::ostream & out)
{
  out << "{";
  // member: time_stamp
  {
    out << "time_stamp: ";
    to_flow_style_yaml(msg.time_stamp, out);
    out << ", ";
  }

  // member: time_stamp_is_present
  {
    out << "time_stamp_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_stamp_is_present, out);
    out << ", ";
  }

  // member: msg_issue_revision
  {
    out << "msg_issue_revision: ";
    to_flow_style_yaml(msg.msg_issue_revision, out);
    out << ", ";
  }

  // member: layer_type
  {
    out << "layer_type: ";
    to_flow_style_yaml(msg.layer_type, out);
    out << ", ";
  }

  // member: layer_type_is_present
  {
    out << "layer_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.layer_type_is_present, out);
    out << ", ";
  }

  // member: layer_id
  {
    out << "layer_id: ";
    to_flow_style_yaml(msg.layer_id, out);
    out << ", ";
  }

  // member: layer_id_is_present
  {
    out << "layer_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.layer_id_is_present, out);
    out << ", ";
  }

  // member: intersections
  {
    out << "intersections: ";
    to_flow_style_yaml(msg.intersections, out);
    out << ", ";
  }

  // member: intersections_is_present
  {
    out << "intersections_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.intersections_is_present, out);
    out << ", ";
  }

  // member: road_segments
  {
    out << "road_segments: ";
    to_flow_style_yaml(msg.road_segments, out);
    out << ", ";
  }

  // member: road_segments_is_present
  {
    out << "road_segments_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_segments_is_present, out);
    out << ", ";
  }

  // member: data_parameters
  {
    out << "data_parameters: ";
    to_flow_style_yaml(msg.data_parameters, out);
    out << ", ";
  }

  // member: data_parameters_is_present
  {
    out << "data_parameters_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.data_parameters_is_present, out);
    out << ", ";
  }

  // member: restriction_list
  {
    out << "restriction_list: ";
    to_flow_style_yaml(msg.restriction_list, out);
    out << ", ";
  }

  // member: restriction_list_is_present
  {
    out << "restriction_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.restriction_list_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MapData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: time_stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_stamp:\n";
    to_block_style_yaml(msg.time_stamp, out, indentation + 2);
  }

  // member: time_stamp_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_stamp_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_stamp_is_present, out);
    out << "\n";
  }

  // member: msg_issue_revision
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msg_issue_revision:\n";
    to_block_style_yaml(msg.msg_issue_revision, out, indentation + 2);
  }

  // member: layer_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "layer_type:\n";
    to_block_style_yaml(msg.layer_type, out, indentation + 2);
  }

  // member: layer_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "layer_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.layer_type_is_present, out);
    out << "\n";
  }

  // member: layer_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "layer_id:\n";
    to_block_style_yaml(msg.layer_id, out, indentation + 2);
  }

  // member: layer_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "layer_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.layer_id_is_present, out);
    out << "\n";
  }

  // member: intersections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intersections:\n";
    to_block_style_yaml(msg.intersections, out, indentation + 2);
  }

  // member: intersections_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intersections_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.intersections_is_present, out);
    out << "\n";
  }

  // member: road_segments
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_segments:\n";
    to_block_style_yaml(msg.road_segments, out, indentation + 2);
  }

  // member: road_segments_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_segments_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_segments_is_present, out);
    out << "\n";
  }

  // member: data_parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_parameters:\n";
    to_block_style_yaml(msg.data_parameters, out, indentation + 2);
  }

  // member: data_parameters_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_parameters_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.data_parameters_is_present, out);
    out << "\n";
  }

  // member: restriction_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "restriction_list:\n";
    to_block_style_yaml(msg.restriction_list, out, indentation + 2);
  }

  // member: restriction_list_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "restriction_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.restriction_list_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MapData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::MapData & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::MapData & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::MapData>()
{
  return "etsi_its_mapem_ts_msgs::msg::MapData";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::MapData>()
{
  return "etsi_its_mapem_ts_msgs/msg/MapData";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::MapData>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::DataParameters>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::IntersectionGeometryList>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LayerID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LayerType>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::MinuteOfTheYear>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::MsgCount>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::RestrictionClassList>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::RoadSegmentList>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::MapData>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::DataParameters>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::IntersectionGeometryList>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LayerID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LayerType>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::MinuteOfTheYear>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::MsgCount>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::RestrictionClassList>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::RoadSegmentList>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::MapData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__TRAITS_HPP_
