// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/NodeOffsetPointXY.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_OFFSET_POINT_XY__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_OFFSET_POINT_XY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_NODE_XY1'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY1 = 0
};

/// Constant 'CHOICE_NODE_XY2'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY2 = 1
};

/// Constant 'CHOICE_NODE_XY3'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY3 = 2
};

/// Constant 'CHOICE_NODE_XY4'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY4 = 3
};

/// Constant 'CHOICE_NODE_XY5'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY5 = 4
};

/// Constant 'CHOICE_NODE_XY6'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_XY6 = 5
};

/// Constant 'CHOICE_NODE_LAT_LON'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__CHOICE_NODE_LAT_LON = 6
};

// Include directives for member types
// Member 'node_xy1'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy20b__struct.h"
// Member 'node_xy2'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy22b__struct.h"
// Member 'node_xy3'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy24b__struct.h"
// Member 'node_xy4'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy26b__struct.h"
// Member 'node_xy5'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy28b__struct.h"
// Member 'node_xy6'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy32b__struct.h"
// Member 'node_lat_lon'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_l_lm_d64b__struct.h"

/// Struct defined in msg/NodeOffsetPointXY in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// NodeOffsetPointXY ::= CHOICE {
  ///   node-XY1         Node-XY-20b,
  ///   node-XY2         Node-XY-22b,
  ///   node-XY3         Node-XY-24b,
  ///   node-XY4         Node-XY-26b,
  ///   node-XY5         Node-XY-28b,
  ///   node-XY6         Node-XY-32b,
  ///   node-LatLon      Node-LLmD-64b,
  ///   regional         RegionalExtension {{Reg-NodeOffsetPointXY}}
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_mapem_ts_msgs__msg__NodeXY20b node_xy1;
  etsi_its_mapem_ts_msgs__msg__NodeXY22b node_xy2;
  etsi_its_mapem_ts_msgs__msg__NodeXY24b node_xy3;
  etsi_its_mapem_ts_msgs__msg__NodeXY26b node_xy4;
  etsi_its_mapem_ts_msgs__msg__NodeXY28b node_xy5;
  etsi_its_mapem_ts_msgs__msg__NodeXY32b node_xy6;
  etsi_its_mapem_ts_msgs__msg__NodeLLmD64b node_lat_lon;
} etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY.
typedef struct etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__Sequence
{
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_OFFSET_POINT_XY__STRUCT_H_
