// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/Position3D.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lat'
#include "etsi_its_mapem_ts_msgs/msg/detail/latitude__struct.hpp"
// Member 'lon'
#include "etsi_its_mapem_ts_msgs/msg/detail/longitude__struct.hpp"
// Member 'elevation'
#include "etsi_its_mapem_ts_msgs/msg/detail/elevation__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__Position3D __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__Position3D __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Position3D_
{
  using Type = Position3D_<ContainerAllocator>;

  explicit Position3D_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lat(_init),
    lon(_init),
    elevation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->elevation_is_present = false;
    }
  }

  explicit Position3D_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lat(_alloc, _init),
    lon(_alloc, _init),
    elevation(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->elevation_is_present = false;
    }
  }

  // field types and members
  using _lat_type =
    etsi_its_mapem_ts_msgs::msg::Latitude_<ContainerAllocator>;
  _lat_type lat;
  using _lon_type =
    etsi_its_mapem_ts_msgs::msg::Longitude_<ContainerAllocator>;
  _lon_type lon;
  using _elevation_type =
    etsi_its_mapem_ts_msgs::msg::Elevation_<ContainerAllocator>;
  _elevation_type elevation;
  using _elevation_is_present_type =
    bool;
  _elevation_is_present_type elevation_is_present;

  // setters for named parameter idiom
  Type & set__lat(
    const etsi_its_mapem_ts_msgs::msg::Latitude_<ContainerAllocator> & _arg)
  {
    this->lat = _arg;
    return *this;
  }
  Type & set__lon(
    const etsi_its_mapem_ts_msgs::msg::Longitude_<ContainerAllocator> & _arg)
  {
    this->lon = _arg;
    return *this;
  }
  Type & set__elevation(
    const etsi_its_mapem_ts_msgs::msg::Elevation_<ContainerAllocator> & _arg)
  {
    this->elevation = _arg;
    return *this;
  }
  Type & set__elevation_is_present(
    const bool & _arg)
  {
    this->elevation_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__Position3D
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__Position3D
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Position3D_ & other) const
  {
    if (this->lat != other.lat) {
      return false;
    }
    if (this->lon != other.lon) {
      return false;
    }
    if (this->elevation != other.elevation) {
      return false;
    }
    if (this->elevation_is_present != other.elevation_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const Position3D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Position3D_

// alias to use template instance with default allocator
using Position3D =
  etsi_its_mapem_ts_msgs::msg::Position3D_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__STRUCT_HPP_
