// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/SegmentAttributeXY.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SEGMENT_ATTRIBUTE_XY__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SEGMENT_ATTRIBUTE_XY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__SegmentAttributeXY __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__SegmentAttributeXY __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SegmentAttributeXY_
{
  using Type = SegmentAttributeXY_<ContainerAllocator>;

  explicit SegmentAttributeXY_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit SegmentAttributeXY_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t RESERVED =
    0u;
  static constexpr uint8_t DO_NOT_BLOCK =
    1u;
  static constexpr uint8_t WHITE_LINE =
    2u;
  static constexpr uint8_t MERGING_LANE_LEFT =
    3u;
  static constexpr uint8_t MERGING_LANE_RIGHT =
    4u;
  static constexpr uint8_t CURB_ON_LEFT =
    5u;
  static constexpr uint8_t CURB_ON_RIGHT =
    6u;
  static constexpr uint8_t LOADINGZONE_ON_LEFT =
    7u;
  static constexpr uint8_t LOADINGZONE_ON_RIGHT =
    8u;
  static constexpr uint8_t TURN_OUT_POINT_ON_LEFT =
    9u;
  static constexpr uint8_t TURN_OUT_POINT_ON_RIGHT =
    10u;
  static constexpr uint8_t ADJACENT_PARKING_ON_LEFT =
    11u;
  static constexpr uint8_t ADJACENT_PARKING_ON_RIGHT =
    12u;
  static constexpr uint8_t ADJACENT_BIKE_LANE_ON_LEFT =
    13u;
  static constexpr uint8_t ADJACENT_BIKE_LANE_ON_RIGHT =
    14u;
  static constexpr uint8_t SHARED_BIKE_LANE =
    15u;
  static constexpr uint8_t BIKE_BOX_IN_FRONT =
    16u;
  static constexpr uint8_t TRANSIT_STOP_ON_LEFT =
    17u;
  static constexpr uint8_t TRANSIT_STOP_ON_RIGHT =
    18u;
  static constexpr uint8_t TRANSIT_STOP_IN_LANE =
    19u;
  static constexpr uint8_t SHARED_WITH_TRACKED_VEHICLE =
    20u;
  static constexpr uint8_t SAFE_ISLAND =
    21u;
  static constexpr uint8_t LOW_CURBS_PRESENT =
    22u;
  static constexpr uint8_t RUMBLE_STRIP_PRESENT =
    23u;
  static constexpr uint8_t AUDIBLE_SIGNALING_PRESENT =
    24u;
  static constexpr uint8_t ADAPTIVE_TIMING_PRESENT =
    25u;
  static constexpr uint8_t RF_SIGNAL_REQUEST_PRESENT =
    26u;
  static constexpr uint8_t PARTIAL_CURB_INTRUSION =
    27u;
  static constexpr uint8_t TAPER_TO_LEFT =
    28u;
  static constexpr uint8_t TAPER_TO_RIGHT =
    29u;
  static constexpr uint8_t TAPER_TO_CENTER_LINE =
    30u;
  static constexpr uint8_t PARALLEL_PARKING =
    31u;
  static constexpr uint8_t HEAD_IN_PARKING =
    32u;
  static constexpr uint8_t FREE_PARKING =
    33u;
  static constexpr uint8_t TIME_RESTRICTIONS_ON_PARKING =
    34u;
  static constexpr uint8_t COST_TO_PARK =
    35u;
  static constexpr uint8_t MID_BLOCK_CURB_PRESENT =
    36u;
  static constexpr uint8_t UN_EVEN_PAVEMENT_PRESENT =
    37u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__SegmentAttributeXY
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__SegmentAttributeXY
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SegmentAttributeXY_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const SegmentAttributeXY_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SegmentAttributeXY_

// alias to use template instance with default allocator
using SegmentAttributeXY =
  etsi_its_mapem_ts_msgs::msg::SegmentAttributeXY_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::DO_NOT_BLOCK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::WHITE_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::MERGING_LANE_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::MERGING_LANE_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::CURB_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::CURB_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::LOADINGZONE_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::LOADINGZONE_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TURN_OUT_POINT_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TURN_OUT_POINT_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::ADJACENT_PARKING_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::ADJACENT_PARKING_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::ADJACENT_BIKE_LANE_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::ADJACENT_BIKE_LANE_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::SHARED_BIKE_LANE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::BIKE_BOX_IN_FRONT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TRANSIT_STOP_ON_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TRANSIT_STOP_ON_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TRANSIT_STOP_IN_LANE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::SHARED_WITH_TRACKED_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::SAFE_ISLAND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::LOW_CURBS_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::RUMBLE_STRIP_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::AUDIBLE_SIGNALING_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::ADAPTIVE_TIMING_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::RF_SIGNAL_REQUEST_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::PARTIAL_CURB_INTRUSION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TAPER_TO_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TAPER_TO_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TAPER_TO_CENTER_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::PARALLEL_PARKING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::HEAD_IN_PARKING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::FREE_PARKING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::TIME_RESTRICTIONS_ON_PARKING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::COST_TO_PARK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::MID_BLOCK_CURB_PRESENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SegmentAttributeXY_<ContainerAllocator>::UN_EVEN_PAVEMENT_PRESENT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SEGMENT_ATTRIBUTE_XY__STRUCT_HPP_
